#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
HOME = os.path.join(os.environ['HOME'])
import locale

import inspect
prefix = os.path.realpath(os.path.abspath(os.path.split(inspect.getfile( inspect.currentframe() ))[0])).split('share')[0]

if 'fr' in locale.setlocale(locale.LC_ALL, ''):
    prefixdoc = prefix+"share/LaTeX-X/doc/html/fr/"
else:
    prefixdoc = prefix+"share/LaTeX-X/doc/html/en/"

# try:
import sys
import gi
gi.require_version('WebKit2', '4.0')
from gi.repository import WebKit2 as WebKit
from gi.repository import GObject
from gi.repository import Gtk
from gi.repository import Pango
import locale
import gettext
from optparse import OptionParser
parser = OptionParser()
parser.add_option("-f", dest="file")
parser.add_option("-m", dest="mode")
(options, args) = parser.parse_args()

import LaTeXXwidgets

class BrowserPage(WebKit.WebView):

    def __init__(self):
        WebKit.WebView.__init__(self)
        settings = self.get_settings()
        settings.set_property("enable-developer-extras", False)
#         self.set_full_content_zoom(True)
#         self.connect_after("populate-popup", self.populate_popup)

    def populate_popup(self, view, menu):
        zoom_in = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_ZOOM_IN, None)
        zoom_in.connect('activate', zoom_in_cb, view)
        menu.append(zoom_in)
        zoom_out = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_ZOOM_OUT, None)
        zoom_out.connect('activate', zoom_out_cb, view)
        menu.append(zoom_out)
        zoom_hundred = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_ZOOM_100, None)
        zoom_hundred.connect('activate', zoom_hundred_cb, view)
        menu.append(zoom_hundred)
        printitem = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_PRINT, None)
        menu.append(printitem)
        printitem.connect('activate', print_cb, view)
        for it in menu.get_children():
            if it.get_children()[0].get_label() == _("Open Link in New Tab"):
                it.show()
            if (it.get_children()[0].get_label() == _("_Open Link")) or (it.get_children()[0].get_label() == _("Open Link in New _Window")) or (it.get_children()[0].get_label() == _("_Download Linked File")) or (it.get_children()[0].get_label() == _("Copy Link Loc_ation")) or (it.get_children()[0].get_label() == _("Open _Image in New Window")) or (it.get_children()[0].get_label() == _("Sa_ve Image As")) or (it.get_children()[0].get_label() == _("Cop_y Image")) or (it.get_children()[0].get_label() == "Copy Image _Address"):
                it.hide()
        zoom_in.show()
        zoom_out.show()
        zoom_hundred.show()
        printitem.show()
        return False

class TabLabel (Gtk.HBox):

    __gsignals__ = {
        "close": (GObject.SignalFlags.RUN_FIRST,
                  None,
                  (GObject.TYPE_OBJECT,))
        }

    def __init__ (self, title, child):
#        GObject.GObject.__init__(self, False, 4)
        GObject.GObject.__init__(self)
        self.title = title
#            self.get_child() = child
        self.label = Gtk.Label(label=title)
        self.label.props.max_width_chars = 30
        self.label.set_ellipsize(Pango.EllipsizeMode.MIDDLE)
        self.label.set_alignment(0.0, 0.5)

        icon = Gtk.Image.new_from_stock(Gtk.STOCK_ORIENTATION_PORTRAIT, Gtk.IconSize.BUTTON)
        close_image = Gtk.Image.new_from_stock(Gtk.STOCK_CLOSE, Gtk.IconSize.MENU)
        close_button = Gtk.Button()
        close_button.set_relief(Gtk.ReliefStyle.NONE)
        close_button.connect("clicked", self._close_tab, child)
        close_button.set_image(close_image)
        self.pack_start(icon, False, False, 0)
        self.pack_start(self.label, True, True, 0)
        self.pack_start(close_button, False, False, 0)

#         self.set_data("label", self.label)
#         self.set_data("close-button", close_button)
        self.connect("style-set", tab_label_style_set_cb)

    def set_label (self, text):
        self.label.set_label(text)

    def _close_tab (self, widget, child):
        self.emit("close", child)

def tab_label_style_set_cb (tab_label, style):
#    context = tab_label.get_pango_context()
#    metrics = context.get_metrics(tab_label.style.font_desc, context.get_language())
#    metrics = context.get_metrics(context.get_font_description(), context.get_language())
#    char_width = metrics.get_approximate_digit_width()
#    (width, height) = Gtk.icon_size_lookup(Gtk.IconSize.MENU)
#    _, width, height = Gtk.icon_size_lookup(Gtk.IconSize.MENU)
#    tab_label.set_size_request(20 * Pango.PIXELS(char_width) + 2 * width,
#                               Pango.PIXELS(metrics.get_ascent() +
#    metrics.get_descent()) + 8)
#    tab_label.set_size_request(20 * char_width + 2 * width, -1)
    tab_label.set_size_request(220, -1)

class ContentPane (Gtk.Notebook):

    __gsignals__ = {
        "focus-view-title-changed": (GObject.SignalFlags.RUN_FIRST,
                                     None,
                                     (GObject.TYPE_OBJECT, GObject.TYPE_STRING,)),
        "new-window-requested": (GObject.SignalFlags.RUN_FIRST,
                                 None,
                                 (GObject.TYPE_OBJECT,))
        }

    def __init__ (self):
        GObject.GObject.__init__(self)
        self.props.scrollable = True
#        self.props.homogeneous = True
        self.connect("switch-page", self._switch_page)

        self.show_all()
        self._hovered_uri = None

    def load (self, text):
        child = self.get_nth_page(self.get_current_page())
        view = child.get_child()
        view.open(text)

    def new_tab_with_webview (self, webview):
        self._construct_tab_view(webview)

    def new_tab (self, url=None):
        browser = BrowserPage()
        self._construct_tab_view(browser, url)

    def _construct_tab_view (self, web_view, url=None):
#         web_view.connect("hovering-over-link", self._hovering_over_link_cb)
#         web_view.connect("populate-popup", self._populate_page_popup_cb)
#         web_view.connect("load-finished", self._view_load_finished_cb)
#         web_view.connect("create-web-view", self._new_web_view_request_cb)
#         web_view.connect("title-changed", self._title_changed_cb)

        scrolled_window = Gtk.ScrolledWindow()
        scrolled_window.props.hscrollbar_policy = Gtk.PolicyType.AUTOMATIC
        scrolled_window.props.vscrollbar_policy = Gtk.PolicyType.AUTOMATIC
        scrolled_window.add(web_view)
        scrolled_window.show_all()

        label = TabLabel(url, scrolled_window)
        label.connect("close", self._close_tab)
        label.show_all()

        new_tab_number = self.append_page(scrolled_window, label)
#        self.set_tab_label_packing(scrolled_window, False, False, Gtk.PACK_START)
        self.set_tab_label(scrolled_window, label)

        self.set_show_tabs(self.get_n_pages() > 1)

        self.show_all()
        self.set_current_page(new_tab_number)

        self._hovered_uri = None
        web_view.load_uri(url)

    def _populate_page_popup_cb(self, view, menu):
        if self._hovered_uri:
            open_in_new_tab = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_ADD, None)
            open_in_new_tab.get_children()[0].set_markup(_("Open Link in New Tab"))
            open_in_new_tab.connect("activate", self._open_in_new_tab, view)
            menu.insert(open_in_new_tab, 0)
            menu.show_all()

    def _open_in_new_tab (self, menuitem, view):
        self.new_tab(self._hovered_uri)

    def _close_tab (self, label, child):
        page_num = self.page_num(child)
        if page_num != -1:
            view = child.get_child()
            view.destroy()
            self.remove_page(page_num)
        self.set_show_tabs(self.get_n_pages() > 1)

    def _switch_page (self, notebook, page, page_num):
        child = self.get_nth_page(page_num)
        view = child.get_child()
        frame = view.get_main_frame()
        self.emit("focus-view-title-changed", frame, frame.props.title)

    def _hovering_over_link_cb (self, view, title, uri):
        self._hovered_uri = uri

    def _title_changed_cb (self, view, frame, title):
        child = self.get_nth_page(self.get_current_page())
        label = self.get_tab_label(child)
        label.set_label(title)
        self.emit("focus-view-title-changed", frame, title)

    def _view_load_finished_cb(self, view, frame):
        child = self.get_nth_page(self.get_current_page())
        label = self.get_tab_label(child)
        title = frame.get_title()
        if not title:
            title = frame.get_uri()
        if title:
            label.set_label(title)

    def _new_web_view_request_cb (self, web_view, web_frame):
        scrolled_window = Gtk.ScrolledWindow()
        scrolled_window.props.hscrollbar_policy = Gtk.PolicyType.AUTOMATIC
        scrolled_window.props.vscrollbar_policy = Gtk.PolicyType.AUTOMATIC
        view = BrowserPage()
        scrolled_window.add(view)
        scrolled_window.show_all()

        vbox = Gtk.VBox(spacing=1)
        vbox.pack_start(scrolled_window, True, True)

        window = Gtk.Window()
        window.add(vbox)
        view.connect("web-view-ready", self._new_web_view_ready_cb)
        return view

    def _new_web_view_ready_cb (self, web_view):
        self.emit("new-window-requested", web_view)

class WebToolbar(Gtk.Toolbar):

    __gsignals__ = {
        "load-requested": (GObject.SignalFlags.RUN_FIRST,
                           None,
                           (GObject.TYPE_STRING,)),
        "new-tab-requested": (GObject.SignalFlags.RUN_FIRST,
                              None, ())
        }

    def __init__(self, location_enabled=True, toolbar_enabled=True):
        GObject.GObject.__init__(self)

        if toolbar_enabled:
            labelclose = Gtk.Label()
            if options.mode == "gui":
                labelclose.set_markup('<b><big>'+_("Close the help to display the LaTeX-X window")+'</big></b>')
            quitButton = Gtk.ToolButton(Gtk.STOCK_CLOSE)
            quitButton.set_label_widget(labelclose)
            quitButton.set_is_important(True)
            quitButton.connect("clicked", quit)
            self.insert(quitButton, -1)
            quitButton.show()
#                 iconclose.show()
            labelclose.show()

        if location_enabled:
            self._entry = Gtk.Entry()
            self._entry.connect('activate', self._entry_activate_cb)
            entry_item = Gtk.ToolItem()
            entry_item.set_expand(True)
            entry_item.add(self._entry)
            self._entry.show()
            self.insert(entry_item, -1)
            entry_item.show()

        if toolbar_enabled:
            addTabButton = Gtk.ToolButton(Gtk.STOCK_ADD)
            addTabButton.connect("clicked", self._add_tab_cb)
            self.insert(addTabButton, -1)
            addTabButton.show()

    def location_set_text (self, text):
        self._entry.set_text(text)

    def _entry_activate_cb(self, entry):
        self.emit("load-requested", entry.props.text)

    def _add_tab_cb(self, button):
        self.emit("new-tab-requested")

class WebBrowser(Gtk.Window):

    def __init__(self):
        GObject.GObject.__init__(self)

        toolbar = WebToolbar()
        content_tabs = ContentPane()
        content_tabs.connect("focus-view-title-changed", self._title_changed_cb, toolbar)
        toolbar.connect("load-requested", load_requested_cb, content_tabs)
        toolbar.connect("new-tab-requested", new_tab_requested_cb, content_tabs)

        vbox = Gtk.VBox(spacing=1)
#        vbox.pack_start(toolbar, expand=False, fill=False)
        vbox.pack_start(toolbar, False, False, 0)
        vbox.pack_start(content_tabs, True, True, 0)

        self.add(vbox)
        self.set_default_size(1200, 900)
        self.set_icon_from_file(prefix+"/share/LaTeX-X/icons/latex-x_48.png")
        self.connect('destroy', destroy_cb, content_tabs)

        self.show_all()
        content_tabs.new_tab("file://"+prefixdoc+options.file)

    def _title_changed_cb (self, tabbed_pane, frame, title, toolbar):
        self.set_title("LaTeX-X-3.0")
        load_committed_cb(tabbed_pane, frame, toolbar)

def new_tab_requested_cb (toolbar, content_pane):
    content_pane.new_tab("about:blank")

def load_requested_cb (widget, text, content_pane):
    if not text:
        return
    content_pane.load(text)

def load_committed_cb (tabbed_pane, frame, toolbar):
    uri = frame.get_uri()
    if uri:
        toolbar.location_set_text(uri)

def destroy_cb(window, content_pane):
    num_pages = content_pane.get_n_pages()
    while num_pages != -1:
        child = content_pane.get_nth_page(num_pages)
        if child:
            view = child.get_child()
        num_pages = num_pages - 1
    window.destroy()
    Gtk.main_quit()

def quit(widget):
    Gtk.main_quit()

def zoom_in_cb(menu_item, web_view):
    web_view.zoom_in()

def zoom_out_cb(menu_item, web_view):
    web_view.zoom_out()

def zoom_hundred_cb(menu_item, web_view):
    if not (web_view.get_zoom_level() == 1.0):
        web_view.set_zoom_level(1.0)

def print_cb(menu_item, web_view):
    mainframe = web_view.get_main_frame()
    mainframe.print_full(Gtk.PrintOperation(), Gtk.PRINT_OPERATION_ACTION_PRINT_DIALOG);

if __name__ == "__main__":
    webbrowser = WebBrowser()
    Gtk.main()
# except:
#     import subprocess
#     from optparse import OptionParser
#     parser = OptionParser()
#     parser.add_option("-f", dest="file")
#     parser.add_option("-m", dest="mode")
#     (options, args) = parser.parse_args()
#     htmlview = open(HOME+"/.latex-x/config/VIEWHTML", 'r').read()
#     subprocess.Popen(htmlview+' file://'+prefixdoc+options.file, shell=True, stdout=subprocess.PIPE)
