#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
HOME = os.path.join(os.environ['HOME'])
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk, Gdk
import time
import sys
from gi.repository import GObject
import subprocess
from optparse import OptionParser
parser = OptionParser()
parser.add_option("-w", dest='windowtype')
parser.add_option("-l", dest='label')
parser.add_option("-r", dest='radiolist')
parser.add_option("-t", dest="btitle")
parser.add_option("-p", dest="prog")
parser.add_option("-v", dest="view")
parser.add_option("--bok", dest="okbutton")
parser.add_option("--bcan", dest="cancelbutton")
parser.add_option("--entry", dest="textentry")
parser.add_option("--icon", dest="iconfile")
parser.add_option("--ftype", dest="filetype")
parser.add_option("--width", dest='width')
parser.add_option("--active", dest='active')
parser.add_option("--nobuttons", action="store_true", dest="buttons")
parser.add_option("--yesbutton", dest='yesbutton')
parser.add_option("--nobutton", dest="nobutton")
parser.add_option("--dir", dest="directory")
parser.add_option("--file", dest="file")
parser.add_option("--logbutton", dest="logbutton")
parser.add_option("--viewbutton", dest="viewbutton")
parser.add_option("--timeout", dest="timeout")  
parser.add_option("--edittex", dest="editortex")
parser.add_option("--ps", dest="psview")
parser.add_option("--pdf", dest="pdfview")
parser.add_option("--edit", dest="editor")
parser.add_option("--html", dest="htmlview")
parser.add_option("--helpbutton", action="store_true", dest="dochelp")
parser.add_option("--tille", dest="wintitle")
parser.add_option("--fselect", dest='fselaction')
(options, args) = parser.parse_args()

import inspect
prefix = os.path.realpath(os.path.abspath(os.path.split(inspect.getfile( inspect.currentframe() ))[0])).split('share')[0]
prefixdoc = prefix+"share/LaTeX-X/doc/html/"

import LaTeXXwidgets
from LaTeXXwidgets import *

try:
    gi.require_version('Vte', '2.90')
    vte_version = '290'
except:
    gi.require_version('Vte', '2.91')
    vte_version = '291'

if options.windowtype == 'tailbox':
    if vte_version == '290':
        gi.require_version('Vte', '2.90')
        from gi.repository import Vte, GLib
    else:
        gi.require_version('Vte', '2.91')
        from gi.repository import Vte, GLib

if options.prog:
    PROG='./'+options.prog

if options.radiolist:
    if '_LaTeXXHISTO_' in options.radiolist:
        list_radios = options.radiolist.split('_LaTeXXHISTO_')
    else:
        list_radios = options.radiolist.split('_')
    for r in list_radios:
        if r == 'radiolistLaTeXXchoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXXchoice1
        if r == 'radiolistLaTeXXchoice2':
            list_radios[list_radios.index(r)] = radiolistLaTeXXchoice2
        if r == 'radiolistLaTeXXchoice3':
            list_radios[list_radios.index(r)] = radiolistLaTeXXchoice3
        if r == 'radiolistLaTeXXchoice4':
            list_radios[list_radios.index(r)] = radiolistLaTeXXchoice4
        if r == 'radiolistLaTeXXviewchoicechoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXXviewchoicechoice1+options.file
        if r == 'radiolistLaTeXXviewchoicechoice2':
            list_radios[list_radios.index(r)] = radiolistLaTeXXviewchoicechoice2+options.file
        if r == 'radiolistLaTeXXviewchoicechoice3':
            list_radios[list_radios.index(r)] = radiolistLaTeXXviewchoicechoice3+options.file
        if r == 'radiolistLaTeXXviewchoicechoice4':
            list_radios[list_radios.index(r)] = radiolistLaTeXXviewchoicechoice4+options.file
        if r == 'radiolistLaTeXXviewchoicechoice5':
            list_radios[list_radios.index(r)] = radiolistLaTeXXviewchoicechoice5+options.file
        if r == 'radiolistLaTeXXchoixmodechoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXXchoixmodechoice1
        if r == 'radiolistLaTeXXchoixmodechoice2':
            list_radios[list_radios.index(r)] = radiolistLaTeXXchoixmodechoice2
        if r == 'radiolistcompilmodechoice1':
            list_radios[list_radios.index(r)] = radiolistcompilmodechoice1
        if r == 'radiolistcompilmodechoice2':
            list_radios[list_radios.index(r)] = radiolistcompilmodechoice2
        if r == 'radiolistLaTeXXexportchoicechoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXXexportchoicechoice1
        if r == 'radiolistLaTeXXexportchoicechoice2':
            list_radios[list_radios.index(r)] = radiolistLaTeXXexportchoicechoice2
        if r == 'radiolistLaTeXXexportchoicechoice3':
            list_radios[list_radios.index(r)] = radiolistLaTeXXexportchoicechoice3
        if r == 'radiolistLaTeXXexportchoicechoice4':
            list_radios[list_radios.index(r)] = radiolistLaTeXXexportchoicechoice4
        if r == 'radiolistLaTeXXexportchoicechoice5':
            list_radios[list_radios.index(r)] = radiolistLaTeXXexportchoicechoice5
        if r == 'radiolistLaTeXpreferenceschoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXpreferenceschoice1+options.editortex
        if r == 'radiolistLaTeXpreferenceschoice2':
            list_radios[list_radios.index(r)] = radiolistLaTeXpreferenceschoice2+options.psview
        if r == 'radiolistLaTeXpreferenceschoice4':
            list_radios[list_radios.index(r)] = radiolistLaTeXpreferenceschoice4+options.pdfview
        if r == 'radiolistLaTeXpreferenceschoice5':
            list_radios[list_radios.index(r)] = radiolistLaTeXpreferenceschoice5+options.editor
        if r == 'radiolistLaTeXpreferenceschoice6':
            list_radios[list_radios.index(r)] = radiolistLaTeXpreferenceschoice6+options.htmlview
        if r == 'radiolistLaTeXpreferenceschoice7':
            list_radios[list_radios.index(r)] = radiolistLaTeXpreferenceschoice7
        if r == 'radiolistLaTeXpreferenceschoice8':
            list_radios[list_radios.index(r)] = radiolistLaTeXpreferenceschoice8
        if r == 'radiolistLaTeXXsaveterminerpschoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXXsaveterminerpschoice1
        if r == 'radiolistLaTeXXsaveterminerpschoice2aFILENAMEpsradiolistLaTeXXsaveterminerpschoice2bREPORI':
            list_radios[list_radios.index(r)] = radiolistLaTeXXsaveterminerpschoice2aFILENAMEpsradiolistLaTeXXsaveterminerpschoice2bREPORI
        if r == 'radiolistLaTeXXsaveterminerpschoice2aFILENAMEdviradiolistLaTeXXsaveterminerpschoice2bREPORI':
            list_radios[list_radios.index(r)] = radiolistLaTeXXsaveterminerpschoice2aFILENAMEdviradiolistLaTeXXsaveterminerpschoice2bREPORI
        if r == 'radiolistLaTeXXsaveterminerpschoice2aFILENAMEdviradiolistLaTeXXsaveterminerpschoice4FILENAMEpsradiolistLaTeXXsaveterminerpschoice2bREPORI':
            list_radios[list_radios.index(r)] = radiolistLaTeXXsaveterminerpschoice2aFILENAMEdviradiolistLaTeXXsaveterminerpschoice4FILENAMEpsradiolistLaTeXXsaveterminerpschoice2bREPORI
        if r == 'radiolistLaTeXXsaveterminerpschoice5':
            list_radios[list_radios.index(r)] = radiolistLaTeXXsaveterminerpschoice5
        if r == 'saveFILENAMEpsasFILELSAVEps':
            list_radios[list_radios.index(r)] = saveFILENAMEpsasFILELSAVEps
        if r == 'saveFILENAMEdviasFILELSAVEdvi':
            list_radios[list_radios.index(r)] = saveFILENAMEdviasFILELSAVEdvi
        if r == 'saveFILENAMEdviandFILENAMEpsasFILELSAVEdviandFILELSAVEps':
            list_radios[list_radios.index(r)] = saveFILENAMEdviandFILENAMEpsasFILELSAVEdviandFILELSAVEps
        if r == 'radiolistLaTeXXsaveterminerpdfchoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXXsaveterminerpdfchoice1
        if r == 'saveFILENAMEpdfinREPORI':
            list_radios[list_radios.index(r)] = saveFILENAMEpdfinREPORI
        if r == 'radiolistLaTeXXsaveterminerpdfchoice3':
            list_radios[list_radios.index(r)] = radiolistLaTeXXsaveterminerpdfchoice3
        if r == 'radiolistLaTeXconfigviewlogbinchoicechoice1':
            list_radios[list_radios.index(r)] = radiolistLaTeXconfigviewlogbinchoicechoice1
        if r == 'radiolistLaTeXconfigviewlogbinchoicechoice2':
            list_radios[list_radios.index(r)] = radiolistLaTeXconfigviewlogbinchoicechoice2

if options.btitle:
    if options.btitle == 'backtitleLaTeXX':
        options.btitle = backtitleLaTeXX
    if options.btitle == 'backtitlerecompilation_COMPILTYPE':
        options.btitle = backtitlerecompilation_COMPILTYPE
    if options.btitle == 'backtitleerrorrecompil':
         options.btitle = backtitleerrorrecompil
    if options.btitle == 'backtitleerrorcompil':
         options.btitle = backtitleerrorcompil
    if options.btitle == 'backtitleLaTeXXviewchoicecompil':
         options.btitle = backtitleLaTeXXviewchoicecompil
    if options.btitle == 'backtitleLaTeXXexportchoiceformat':
         options.btitle = backtitleLaTeXXexportchoiceformat
    if options.btitle == 'backtitleLaTeXXsaveterminerps':
         options.btitle = backtitleLaTeXXsaveterminerps
    if options.btitle == 'backtitleLaTeXXsavesave':
         options.btitle = backtitleLaTeXXsavesave
    if options.btitle == 'backtitleLaTeXXsaveterminerpdf':
         options.btitle = backtitleLaTeXXsaveterminerpdf
    if options.btitle == 'backtitleexecuteviewps':
         options.btitle = backtitleexecuteviewps
    if options.btitle == 'backtitleexecuteviewpdf':
         options.btitle = backtitleexecuteviewpdf
    if options.btitle == 'backtitlelock':
         options.btitle = backtitlelock
    if options.btitle == 'backtitleerrorparameditor':
         options.btitle = backtitleerrorparameditor
    if options.btitle == 'backtitleerrordirnameeditor':
         options.btitle = backtitleerrordirnameeditor
    if options.btitle == 'backtitleerrorpermission':
         options.btitle = backtitleerrorpermission
    if options.btitle == 'backtitleerrorext':
         options.btitle = backtitleerrorext
    if options.btitle == 'backtitleerrornonlatex2e':
         options.btitle = backtitleerrornonlatex2e
    if options.btitle == 'backtitleconfigviewpdf':
         options.btitle = backtitleconfigviewpdf
    if options.btitle == 'backtitleconfigviewpostscript':
         options.btitle = backtitleconfigviewpostscript
    if options.btitle == 'backtitleconfigeditortex':
         options.btitle = backtitleconfigeditortex
    if options.btitle == 'backtitleconfigeditortext':
         options.btitle = backtitleconfigeditortext
    if options.btitle == 'backtitleLaTeXconfigeditorbin':
         options.btitle = backtitleLaTeXconfigeditorbin
    if options.btitle == 'backtitleLaTeXconfigeditorbinerror':
         options.btitle = backtitleLaTeXconfigeditorbinerror
    if options.btitle == 'backtitleLaTeXconfigeditortexbin':
         options.btitle = backtitleLaTeXconfigeditortexbin
    if options.btitle == 'backtitleLaTeXconfigeditortexbinerror':
         options.btitle = backtitleLaTeXconfigeditortexbinerror
    if options.btitle == 'backtitleLaTeXconfigviewlogbinchoice':
         options.btitle = backtitleLaTeXconfigviewlogbinchoice
    if options.btitle == 'backtitleLaTeXconfigviewlogdvipschoice':
         options.btitle = backtitleLaTeXconfigviewlogdvipschoice
    if options.btitle == 'backtitleLaTeXconfigviewpdfbin':
         options.btitle = backtitleLaTeXconfigviewpdfbin
    if options.btitle == 'backtitleLaTeXconfigviewpdfbinerror':
         options.btitle = backtitleLaTeXconfigviewpdfbinerror
    if options.btitle == 'backtitleLaTeXconfigviewpsbin':
         options.btitle = backtitleLaTeXconfigviewpsbin
    if options.btitle == 'backtitleLaTeXconfigviewpsbinerror':
         options.btitle = backtitleLaTeXconfigviewpsbinerror
    if options.btitle == 'backtitlecompilmode':
         options.btitle = backtitlecompilmode
    if options.btitle == 'UNINSTALLT':
         options.btitle = UNINSTALLT
    if options.btitle == 'backtitleerrornonpermission':
         options.btitle = backtitleerrornonpermission
    if options.btitle == 'backtitleLaTeXXchoix':
         options.btitle = backtitleLaTeXXchoix
    if options.btitle == 'backtitleerrorexttex':
         options.btitle = backtitleerrorexttex
    if options.btitle == 'infoboxupdateerrortitle':
         options.btitle = infoboxupdateerrortitle
    if options.btitle == 'infoprecomppstpdfnopage':
         options.btitle = infoprecomppstpdfnopage
    if options.btitle == 'backtitleLaTeXXrecents':
         options.btitle = backtitleLaTeXXrecents
    if options.btitle == 'backtitleLaTeXconfigviewhtmlbin':
         options.btitle = backtitleLaTeXconfigviewhtmlbin
    if options.btitle == 'backtitleLaTeXpreferences':
         options.btitle = backtitleLaTeXpreferences

if options.label:
    if options.label == 'radiolistLaTeXX':
        options.label = radiolistLaTeXX
    if options.label == 'yesnorecompilation1_tmp_FILENAMEtex_yesnorecompilation2':
        options.label = yesnorecompilation1_tmp_FILENAMEtex_yesnorecompilation2
    if options.label == 'emerstoprecompil1_FILENAMEtex_emerstoprecompil2_FILENAMElog_emerstoprecompil3':
        options.label = emerstoprecompil1_FILENAMEtex_emerstoprecompil2_FILENAMElog_emerstoprecompil3
    if options.label == 'msgboxerrorrecompil1_FILENAMElog_msgboxerrorrecompil2':
        options.label = msgboxerrorrecompil1_FILENAMElog_msgboxerrorrecompil2
    if options.label == 'infoboxemerlogcompil1_FILENAMEtex_infoboxemerlogcompil2_FILENAMElog_infoboxemerlogcompil3':
        options.label = infoboxemerlogcompil1_FILENAMEtex_infoboxemerlogcompil2_FILENAMElog_infoboxemerlogcompil3
    if options.label == 'yesnowarningfirstcompil1_EXPORTTYPE_yesnowarningfirstcompil2_EXPORTTYPE_yesnowarningfirstcompil3':
        options.label = yesnowarningfirstcompil1_EXPORTTYPE_yesnowarningfirstcompil2_EXPORTTYPE_yesnowarningfirstcompil3
    if options.label == 'yesnoerrorcompil1_EXPORTTYPE_yesnoerrorcompil2_EXPORTTYPE_yesnoerrorcompil3_EXPORTTYPE_yesnoerrorcompil4_newline_yesnoerrorfirstcompil':
        options.label = yesnoerrorcompil1_EXPORTTYPE_yesnoerrorcompil2_EXPORTTYPE_yesnoerrorcompil3_EXPORTTYPE_yesnoerrorcompil4_newline_yesnoerrorfirstcompil
    if options.label == 'labelnopageoutputfirstcompil_FILENAME':
        options.label = labelnopageoutputfirstcompil_FILENAME
    if options.label == 'infoboxemerlogcompil1_FILENAMEtex_infoboxemerlogcompil2_newline_FILENAMElog_newline_infoboxemerlogcompil3':
        options.label = infoboxemerlogcompil1_FILENAMEtex_infoboxemerlogcompil2_newline_FILENAMElog_newline_infoboxemerlogcompil3
    if options.label == 'FILENAMEtex_newline_yesnonoupdatecompilneeded':
        options.label = FILENAMEtex_newline_yesnonoupdatecompilneeded
    if options.label == 'FILENAMEtexnewline_yesnonoupdatecompilneededpsopen1_newline_FILENAMEps_newline_yesnonoupdatecompilneededpsopen2':
        options.label = FILENAMEtexnewline_yesnonoupdatecompilneededpsopen1_newline_FILENAMEps_newline_yesnonoupdatecompilneededpsopen2
    if options.label == 'FILENAMEtex_updatecompilnotchangeerror_logfile':
        options.label = FILENAMEtex_updatecompilnotchangeerror_logfile
    if options.label == 'yesnowarningupdatecompil1_EXPORTTYPE_yesnowarningupdatecompil2_EXPORTTYPE_yesnowarningupdatecompil3':
        options.label = yesnowarningupdatecompil1_EXPORTTYPE_yesnowarningupdatecompil2_EXPORTTYPE_yesnowarningupdatecompil3
    if options.label == 'yesnoerrorcompil1_EXPORTTYPE_yesnoerrorcompil2_EXPORTTYPE_yesnoerrorcompil3_EXPORTTYPE_yesnoerrorcompil4':
        options.label = yesnoerrorcompil1_EXPORTTYPE_yesnoerrorcompil2_EXPORTTYPE_yesnoerrorcompil3_EXPORTTYPE_yesnoerrorcompil4
    if options.label == 'radiolistLaTeXXviewchoicecompil2':
        options.label = radiolistLaTeXXviewchoicecompil2
    if options.label == 'radiolistLaTeXXexportchoiceformat1_newline_FILENAMEtex_newline_radiolistLaTeXXexportchoiceformat2':
        options.label = radiolistLaTeXXexportchoiceformat1_newline_FILENAMEtex_newline_radiolistLaTeXXexportchoiceformat2
    if options.label == 'radiolistLaTeXXsaveterminerps1_newline_tmp_FILENAMEtex_newline_radiolistLaTeXXsaveterminerps2':
        options.label = radiolistLaTeXXsaveterminerps1_newline_tmp_FILENAMEtex_newline_radiolistLaTeXXsaveterminerps2
    if options.label == 'radiolistLaTeXXsavesave':
        options.label = radiolistLaTeXXsavesave
    if options.label == 'radiolistLaTeXXsaveterminerpdf1_tmp_FILENAMEtex_radiolistLaTeXXsaveterminerpdf2':
        options.label = radiolistLaTeXXsaveterminerpdf1_tmp_FILENAMEtex_radiolistLaTeXXsaveterminerpdf2
    if options.label == 'yesnexecuteviewpsFILENAMEps':
        options.label = yesnexecuteviewpsFILENAMEps
    if options.label == 'yesnexecuteviewpdfFILENAMEpdf':
        options.label = yesnexecuteviewpdfFILENAMEpdf
    if options.label == 'yesnolock':
        options.label = yesnolock
    if options.label == 'infoboxerrorparameditor':
        options.label = infoboxerrorparameditor
    if options.label == 'infoboxerrordirnameeditor':
        options.label = infoboxerrordirnameeditor
    if options.label == 'infoboxerrornonpermission':
        options.label = infoboxerrornonpermission
    if options.label == 'infoboxerrorext':
        options.label = infoboxerrorext
    if options.label == 'msgboxerrornonlatex2e':
        options.label = msgboxerrornonlatex2e
    if options.label == 'infoboxconfigviewpdf':
        options.label = infoboxconfigviewpdf
    if options.label == 'infoboxconfigviewpostscript':
        options.label = infoboxconfigviewpostscript
    if options.label == 'infoboxconfigeditortext':
        options.label = infoboxconfigeditortext
    if options.label == 'inputboxLaTeXconfigeditorbin':
        options.label = inputboxLaTeXconfigeditorbin
    if options.label == 'infoboxLaTeXconfigeditorbinerror':
        options.label = infoboxLaTeXconfigeditorbinerror
    if options.label == 'inputboxLaTeXconfigeditortexbin':
        options.label = inputboxLaTeXconfigeditortexbin
    if options.label == 'infoboxLaTeXconfigeditortexbinerror':
        options.label = infoboxLaTeXconfigeditortexbinerror
    if options.label == 'radiolistLaTeXconfigviewlogbinchoice':
        options.label = radiolistLaTeXconfigviewlogbinchoice
    if options.label == 'radiolistLaTeXconfigviewlogdvipschoice':
        options.label = radiolistLaTeXconfigviewlogdvipschoice
    if options.label == 'inputboxTeXconfigviewpdfbin':
        options.label = inputboxTeXconfigviewpdfbin
    if options.label == 'infoboxLaTeXconfigviewpdfbinerror':
        options.label = infoboxLaTeXconfigviewpdfbinerror
    if options.label == 'inputboxLaTeXconfigviewpsbin':
        options.label = inputboxLaTeXconfigviewpsbin
    if options.label == 'radiolistcompilmode':
        options.label = radiolistcompilmode
    if options.label == 'infoboxerrornonlatex2e1_FILE_infoboxerrornonlatex2e2':
        options.label = infoboxerrornonlatex2e1_FILE_infoboxerrornonlatex2e2
    if options.label == 'UNINSTALLQ':
        options.label = UNINSTALLQ
    if options.label == 'infoboxerrornonpermission1_FILE_infoboxerrornonpermission2':
        options.label = infoboxerrornonpermission1_FILE_infoboxerrornonpermission2
    if options.label == 'backtitleLaTeXXchoixmode_FILE':
        options.label = backtitleLaTeXXchoixmode_FILE
    if options.label == 'infoboxerrorexttex':
        options.label = infoboxerrorexttex
    if options.label == 'FILENAMEtex_yesnotestpstpdf1_yesnotestpstpdf2':
        options.label = FILENAMEtex_yesnotestpstpdf1_yesnotestpstpdf2
    if options.label == 'infoboxupdateerror123456':
        options.label = infoboxupdateerror123456
    if options.label == 'infoboxemerlogcompil12_FILENAMEtex_infoboxemerlogcompil2_FILENAMElog_infoboxemerlogcompil3':
        options.label = infoboxemerlogcompil12_FILENAMEtex_infoboxemerlogcompil2_FILENAMElog_infoboxemerlogcompil3
    if options.label == 'precomppstpdf123456':
        options.label = precomppstpdf123456
    if options.label == 'yesnoprecomperror12345':
        options.label = yesnoprecomperror12345
    if options.label == 'FILENAMEtex_yesnonoupdatecompilneededpsopen12':
        options.label = FILENAMEtex_yesnonoupdatecompilneededpsopen12
    if options.label == 'inputboxLaTeXconfigviewhtmlbin':
        options.label = inputboxLaTeXconfigviewhtmlbin
    if options.label == 'radiolistLaTeXpreferences':
        options.label = radiolistLaTeXpreferences

if options.yesbutton:
    if options.yesbutton == 'oklabelrecompilation_FILENAMEtex':
        options.yesbutton = oklabelrecompilation_FILENAMEtex
    if options.yesbutton == 'oklabelwarningcompil':
        options.yesbutton = oklabelwarningcompil
    if options.yesbutton == 'oklabelerrorcompil':
        options.yesbutton = oklabelerrorcompil
    if options.yesbutton == 'prepstpdfcorr':
        options.yesbutton = prepstpdfcorr

if options.nobutton:
    if options.nobutton == 'cancellabelrecompilation':
            options.nobutton = cancellabelrecompilation
    if options.nobutton == 'cancellabelwarningcompil_EXPORTTYPE':
            options.nobutton = cancellabelwarningcompil_EXPORTTYPE
    if options.nobutton == 'cancellabelerrorcompil_EXPORTTYPE':
            options.nobutton = cancellabelerrorcompil_EXPORTTYPE
    if options.nobutton == 'prepstfcont':
            options.nobutton = prepstfcont

if options.logbutton:
    if options.logbutton == 'oklabelfirstviewwarningcompil':
        options.logbutton = oklabelfirstviewwarningcompil
    if options.logbutton == 'oklabelfirstviewlogerrorcompil':
        options.logbutton = oklabelfirstviewlogerrorcompil

if options.viewbutton:
    if options.viewbutton == 'cancellabelfirstviewwarningcompil_EXPORTTYPE':
        options.viewbutton = cancellabelfirstviewwarningcompil_EXPORTTYPE
    if options.viewbutton == 'cancellabelerrorcompil_EXPORTTYPE':
        options.viewbutton = cancellabelerrorcompil_EXPORTTYPE
    if options.viewbutton == 'cancellabelwarningcompil_EXPORTTYPE':
        options.viewbutton = cancellabelwarningcompil_EXPORTTYPE

class PyDialog:
    
    def check_proc(self, pid):
        try:
            os.kill(pid, 0)
            OUT = 'YES'
        except:
            OUT = 'NO'
        return OUT
    
    def term_colors(self, term):
        if vte_version == '290':
            term.set_color_foreground(Gdk.color_parse('black'))
            term.set_color_background(Gdk.color_parse('white'))
        else:
            term.set_color_foreground(Gdk.RGBA(0, 0, 0, 1))
            term.set_color_background(Gdk.RGBA(1, 1, 1, 1))
    
    if vte_version == '290':
        def on_child_exited(self, widget, button):
            if options.view == 'view':
                button.show()
            if options.view == 'hide':
                Gtk.main_quit()
    else:
        def on_child_exited(self, NULL, widget, button):
            if options.view == 'view':
                button.show()
                if options.view == 'hide':
                    Gtk.main_quit()
    
    def close(self, widget):
        Gtk.main_quit()
    
    def ok_radiobox(self, widget, radio):
        for r in radio.get_group():
            if r.get_active():
                nb = len(radio.get_group())-radio.get_group().index(r)-1
        print(nb) 
        Gtk.main_quit()
    
    def ok_yesno(self, widget, win):
        print(0)
        Gtk.main_quit()
    
    def cancel_yesno(self, widget, win):
        print(1)
        Gtk.main_quit()
    
    def ok_input(self, widget, entry, win):
        print(entry.get_text())
        Gtk.main_quit()
    
    def help_latexx(self, widget, win):
        win.hide()
        while Gtk.events_pending():
            Gtk.main_iteration()
        HELP = subprocess.Popen(prefix+"share/LaTeX-X/lib/DocBrowser.py -f doc.html -m gui", shell=True, stdout=subprocess.PIPE)
        for n in range(50000):
            if HELP.poll() == None:
                time.sleep(0.1)
            else:
                break
        win.show()
    
    def close_window(self, widget):
        Gtk.main_quit()
    
    def __init__(self):
        
        if options.windowtype != 'fselect':
            dia_window = Gtk.Window(Gtk.WindowType.TOPLEVEL)
            dia_window.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
            dia_window.set_title("LaTeX-X 3.0")
            dia_window.set_icon_from_file(prefix+"/share/LaTeX-X/icons/latex-x_48.png")
            dia_window.set_keep_above(True)
            vbox = Gtk.VBox(False, 0)
            vbox.set_border_width(2)
            dia_window.add(vbox)
        if (options.windowtype == 'yesno') or (options.windowtype == 'msgbox') or (options.windowtype == 'infobox') or (options.windowtype == "radiobox") or (options.windowtype == 'inputbox'):
            hbox_title = Gtk.HBox()
            vbox.pack_start(hbox_title, False, False, 5)
            hbox_title.show()
            label_title = Gtk.Label()
            label_title.set_markup('<b>'+options.btitle.replace('newline', '\n')+'</b>')
            label_title.set_justify(Gtk.Justification.CENTER)
            hbox_title.pack_start(label_title, True, False, 2)
            label_title.show()
            tsep = Gtk.HSeparator()
            vbox.pack_start(tsep, False, False, 2)
            tsep.show()
        if options.windowtype == 'radiobox':
            vbox.show()
            topbox = Gtk.HBox()
            vbox.pack_start(topbox, False, False, 5)
            topbox.show()
            logo = Gtk.Image()
            if options.iconfile:
                logo.set_from_file(prefix+"/share/LaTeX-X/images/"+options.iconfile)
            else:
                logo.set_from_file(prefix+"/share/LaTeX-X/icons/latex-x.png")
            topbox.pack_start(logo, False, False, 5)
            logo.show()
            label_radio = Gtk.Label()
            label_radio.set_markup(options.label.replace('newline', '\n'))
            if options.width:
                label_radio.set_line_wrap(True)
                label_radio.set_justify(Gtk.Justification.FILL)
            else:
                label_radio.set_justify(Gtk.Justification.CENTER)
            topbox.pack_start(label_radio, True, False, 5)
            label_radio.show()
            sw_radio = Gtk.ScrolledWindow()
            sw_radio.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.NEVER)
            vbox.pack_start(sw_radio, False, False, 5)
            sw_radio.show()
            vbox_radio = Gtk.VBox()
            sw_radio.add_with_viewport(vbox_radio)
            vbox_radio.show()
            radio_first = Gtk.RadioButton.new_with_label_from_widget(None, list_radios[0])
            vbox_radio.pack_start(radio_first, False, False, 3)
            radio_first.show()
            if len(list_radios) >= 2:
                for ra in list_radios[1:]:
                    radio = Gtk.RadioButton.new_with_label_from_widget(radio_first, ra)
                    vbox_radio.pack_start(radio, False, False, 3)
                    radio.show()
            if options.active:
                radio_first.get_group()[len(list_radios)-1-int(options.active)].set_active(True)
            hbox_button = Gtk.HBox()
            vbox.pack_start(hbox_button, True, False, 5)
            hbox_button.show()
            dia_window.show()
            dia_window.connect("destroy", self.close_window)
            if options.okbutton == 'OK':
                ok_button = Gtk.Button(stock=Gtk.STOCK_OK)
            elif options.okbutton == 'FORWARD':
                ok_button = Gtk.Button(stock=Gtk.STOCK_GO_FORWARD)
            else:
                ok_button = Gtk.Button(stock=Gtk.STOCK_OK)
            hbox_button.pack_start(ok_button, True, False, 5)
            ok_button.connect("clicked", self.ok_radiobox, radio_first)
            ok_button.show()
            if options.dochelp:
                help_button = Gtk.Button(stock=Gtk.STOCK_HELP)
                hbox_button.pack_start(help_button, True, False, 5)
                help_button.show()
                help_button.connect("clicked", self.help_latexx, dia_window)
            if options.cancelbutton == 'QUIT':
                close_button = Gtk.Button(stock=Gtk.STOCK_QUIT)
            elif options.cancelbutton == 'BACK':
                close_button = Gtk.Button(stock=Gtk.STOCK_GO_BACK)
            else:
                close_button = Gtk.Button(stock=Gtk.STOCK_QUIT)
            hbox_button.pack_start(close_button, True, False, 5)
            close_button.show()
            close_button.connect("clicked", self.close_window)
            if options.width:
                dia_window.set_size_request(int(options.width), -1)
            while Gtk.events_pending():
                Gtk.main_iteration()
        elif options.windowtype == 'inputbox':
            vbox.show()
            topbox = Gtk.HBox()
            vbox.pack_start(topbox, False, False, 5)
            topbox.show()
            logo = Gtk.Image()
            if options.iconfile:
                logo.set_from_file(prefix+"/share/LaTeX-X/images/"+options.iconfile)
            topbox.pack_start(logo, False, False, 5)
            logo.show()
            label_input = Gtk.Label()
            label_input.set_markup(options.label.replace('newline', '\n'))
            topbox.pack_start(label_input, True, False, 5)
            label_input.show()
            entry = Gtk.Entry()
            entry.set_max_length(0)
            entry.set_editable(True)
            entry.set_text(options.textentry)
            vbox.pack_start(entry, True, False, 5)
            entry.show()
            hbox_button = Gtk.HBox()
            vbox.pack_start(hbox_button, True, False, 5)
            hbox_button.show()
            ok_button = Gtk.Button(stock=Gtk.STOCK_OK)
            hbox_button.pack_start(ok_button, True, False, 2)
            ok_button.show()
            ok_button.connect("clicked", self.ok_input, entry, dia_window)
            dia_window.show()
            dia_window.connect("destroy", self.ok_input, entry, None)
        elif options.windowtype == 'yesno':
            vbox.show()
            topbox = Gtk.HBox()
            vbox.pack_start(topbox, False, False, 5)
            topbox.show()
            if options.iconfile:
                logo = Gtk.Image()
                logo.set_from_file(prefix+"/share/LaTeX-X/images/"+options.iconfile)
                topbox.pack_start(logo, False, False, 5)
                logo.show()
            label_yesno = Gtk.Label()
            label_yesno.set_markup(options.label.replace('newline', '\n'))
            topbox.pack_start(label_yesno, True, False, 5)
            label_yesno.show()
            hbox_buttons = Gtk.HBox()
            vbox.pack_start(hbox_buttons, True, False, 5)
            hbox_buttons.show()
            if options.yesbutton:
                if options.yesbutton == 'STOCKYES':
                    ok_button = Gtk.Button(stock=Gtk.STOCK_YES)
                elif options.yesbutton == 'STOCKCLOSE':
                    ok_button = Gtk.Button(stock=Gtk.STOCK_CLOSE)
                else:
                    ok_button = Gtk.Button(options.yesbutton)
            else:
                ok_button = Gtk.Button(stock=Gtk.STOCK_OK)
            if options.nobutton:
                if options.nobutton == 'STOCKNO':
                    cancel_button = Gtk.Button(stock=Gtk.STOCK_NO)
                elif options.nobutton == 'STOCKDELETE':
                    cancel_button = Gtk.Button(stock=Gtk.STOCK_DELETE)
                else:
                    cancel_button = Gtk.Button(options.nobutton)
            else:
                cancel_button = Gtk.Button(stock=Gtk.STOCK_CANCEL)
            hbox_buttons.pack_start(ok_button, True, False, 2)
            hbox_buttons.pack_start(cancel_button, True, False, 2)
            ok_button.show()
            cancel_button.show()
            ok_button.connect("clicked", self.ok_yesno, dia_window)
            cancel_button.connect("clicked", self.cancel_yesno, dia_window)
            dia_window.show()
            dia_window.connect("destroy", self.close_window)
        elif (options.windowtype == 'msgbox') or (options.windowtype == 'infobox'):
            vbox.show()
            topbox = Gtk.HBox()
            vbox.pack_start(topbox, False, False, 5)
            topbox.show()
            if options.iconfile:
                logo = Gtk.Image()
                logo.set_from_file(prefix+"/share/LaTeX-X/images/"+options.iconfile)
                topbox.pack_start(logo, False, False, 5)
                logo.show()
            label_msgbox = Gtk.Label()
            label_msgbox.set_markup(options.label.replace('newline', '\n'))
            topbox.pack_start(label_msgbox, True, False, 5)
            label_msgbox.show()
            if not options.buttons:
                hbox_button = Gtk.HBox()
                vbox.pack_start(hbox_button, True, False, 5)
                hbox_button.show()
                close_button = Gtk.Button(stock=Gtk.STOCK_CLOSE)
                hbox_button.pack_start(close_button, True, False, 2)
                close_button.show()
                close_button.connect("clicked", self.close_window)
            dia_window.show()
            while Gtk.events_pending():
                Gtk.main_iteration()
            if options.windowtype == 'msgbox':
                dia_window.connect("destroy", self.close_window)
            if options.windowtype == 'infobox':
                if options.timeout:
                    GObject.timeout_add(int(options.timeout), self.close_window, dia_window)
        elif options.windowtype == 'fselect':
            if options.fselaction == 'open':
                select_window = Gtk.FileChooserDialog(options.btitle, None, Gtk.FileChooserAction.OPEN, (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL, Gtk.STOCK_OPEN, Gtk.ResponseType.OK))
                select_window.set_title("LaTeX-X 2.0 - ")
            if options.fselaction == 'save':
                select_window = Gtk.FileChooserDialog(options.btitle, None, Gtk.FileChooserAction.SAVE, (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL, Gtk.STOCK_OPEN, Gtk.ResponseType.OK))
                select_window.set_title("LaTeX-X 2.0 - "+_("Type a name of file WITHOUT EXTENTION"))
            if options.directory:
                select_window.set_current_folder(options.directory)
            if options.filetype:
                if options.filetype == 'latex':
                    filter = Gtk.FileFilter()
                    filter.set_name("LaTeX")
                    filter.add_pattern("*.tex")
                    select_window.add_filter(filter)
            select_window.set_default_response(Gtk.ResponseType.OK)
            response = select_window.run()
            if response == Gtk.ResponseType.OK:
                print(select_window.get_filename())
                select_window.destroy()
                sys.exit(0)
            else:
                print('no_choice')
                select_window.destroy()
                sys.exit(0)
        elif options.windowtype == 'textbox':
            vbox.show()
            vbox1 = Gtk.VBox()
            vbox.pack_start(vbox1, True, True, 0)
            vbox1.show()
            sw = Gtk.ScrolledWindow()
            sw.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
            vbox1.pack_start(sw, True, True, 0)
            textview = Gtk.TextView()
            textbuffer = textview.get_buffer()
            textview.set_left_margin(5)
            textview.set_right_margin(5)
            textview.set_editable(False)
            textview.set_wrap_mode(Gtk.WrapMode.WORD)
            textview.set_justification(Gtk.Justification.FILL)
            sw.add(textview)
            sw.show()
            textview.show()
            if os.path.isfile(options.file):
                readfile = open(options.file, "r")
                if readfile:
#                     string = readfile.read().decode("iso8859_15")
                    string = readfile.read()
                    readfile.close()
                    textbuffer.set_text(string)
            else:
                textbuffer.set_text(options.file)
            while Gtk.events_pending():
                Gtk.main_iteration()
            textview.scroll_to_iter(textview.get_buffer().get_end_iter(), 0.0, False, 0.5, 0.5)
            hbox_buttons = Gtk.HBox()
            vbox1.pack_start(hbox_buttons, False, False, 5)
            hbox_buttons.show()
            if options.logbutton:
                log_button = Gtk.Button(options.logbutton)
                hbox_buttons.pack_start(log_button, True, False, 2)
                log_button.connect("clicked", self.ok_yesno, dia_window)
                log_button.show()
            else:
                close_button = Gtk.Button(stock=Gtk.STOCK_CLOSE)
                hbox_buttons.pack_start(close_button, True, False, 5)
                close_button.connect("clicked", self.close_window)
                close_button.show()
            if options.viewbutton:
                view_button = Gtk.Button(options.viewbutton)
                hbox_buttons.pack_start(view_button, True, False, 2)
                view_button.connect("clicked", self.cancel_yesno, dia_window)
                view_button.show()
            dia_window.set_default_size(720, 650)
            dia_window.set_position(Gtk.WindowPosition.CENTER)
            dia_window.show()
            dia_window.connect("destroy", self.close_window)
            csshelp = Gtk.CssProvider()
            csshelp.load_from_data(b"""
                GtkTextView { background-image: none; }
                GtkTextView { border-image-source: none; }
                GtkTextView { background-color: white; }
                GtkTextView { color: black; }
                GtkTextView:selected { background-color: #3E5E74; }
                GtkTextView:selected { color: white; }
            """)
            Gtk.StyleContext.add_provider_for_screen(Gdk.Screen.get_default(), csshelp, Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
        elif options.windowtype == 'tailbox':
            dia_window.set_title(_("Compilation of ")+filename+'.tex')
            vbox.show()
            hbox_term = Gtk.HBox()
            vbox.pack_start(hbox_term, True, True, 5)
            sw = Gtk.ScrolledWindow()
            hbox_term.add(sw)
            term = Vte.Terminal()
#             term.set_scrollback_lines(10000)
            term.set_scrollback_lines(-1)
            term.connect('realize', self.term_colors)
            term.set_encoding('utf-8')
            sw.add(term)
            sw.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
            hbox_button = Gtk.HBox()
            vbox.pack_start(hbox_button, False, False, 5)
            close_button = Gtk.Button(stock=Gtk.STOCK_CLOSE)
            hbox_button.pack_start(close_button, True, False, 2)
            close_button.connect("clicked", self.close)
            term.connect('child-exited', self.on_child_exited, close_button)
            if options.view == 'view':
                hbox_term.show()
                sw.show()
                term.show()
                hbox_button.show()
                dia_window.set_default_size(750, 650)
                dia_window.show()
                dia_window.set_keep_above(True)
            if options.view == 'hide':
                hbox_title = Gtk.HBox()
                vbox.pack_start(hbox_title, False, False, 5)
                hbox_title.show()
                label_title = Gtk.Label()
                label_title.set_markup('<b>'+_("COMPLETE COMPILATION ")+compiltype+_(" RUNNING")+'</b>')
                label_title.set_justify(Gtk.Justification.CENTER)
                hbox_title.pack_start(label_title, True, False, 2)
                label_title.show()
                tsep = Gtk.HSeparator()
                vbox.pack_start(tsep, False, False, 2)
                tsep.show()
                topbox = Gtk.HBox()
                vbox.pack_start(topbox, False, False, 5)
                topbox.show()
                logo = Gtk.Image()
                logo.set_from_file(prefix+"/share/LaTeX-X/images/"+options.iconfile)
                topbox.pack_start(logo, False, False, 5)
                logo.show()
                label_msg = Gtk.Label()
                label_msg.set_markup(_("Be patient please...")+'\n'+_("Compilation of")+'\n'+filename+'.tex')
                label_msg.set_justify(Gtk.Justification.CENTER)
                topbox.pack_start(label_msg, True, False, 5)
                label_msg.show()
                dia_window.show()
                dia_window.set_keep_above(True)
            while Gtk.events_pending():
                Gtk.main_iteration()
            if vte_version == '290':
                compilation = term.fork_command_full(0, "prefix", [PROG], '', 0, None, None)
            else:
                try:
                    compilation = term.spawn_sync(0, "prefix", [PROG], '', 0, None, None)
                except:
                    compilation = term.spawn_async(0, "prefix", [PROG], '', 0, None, None)
        else:
            print('no window')
            sys.exit(0)

def main():
    Gtk.main()
    return 0

if __name__ == "__main__":
    PyDialog()
    main()

