#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
HOME = os.path.join(os.environ['HOME'])
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk
import locale
import gettext

import inspect
prefix = os.path.realpath(os.path.abspath(os.path.split(inspect.getfile( inspect.currentframe() ))[0])).split('share')[0]

APP = 'LaTeX-X'
DIR = prefix+"/share/locale/"

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext
gettext.install(APP, DIR)

reptemp = HOME+"/.latex-x/tmp"
if os.path.isfile(reptemp+'/COMPILTYPE'):
    compiltype = open(reptemp+'/COMPILTYPE', 'r').read().rstrip()
else:
    compiltype = ''
if os.path.isfile(reptemp+'/FILENAME'):
    filename = open(reptemp+'/FILENAME', 'r').read().rstrip()
else:
    filename = ''
if os.path.isfile(reptemp+'/FILE'):
    FILE = open(reptemp+'/FILE', 'r').read().rstrip()
else:
    FILE = ''
if os.path.isfile(reptemp+'/FILELSAVE'):
    filesave = open(reptemp+'/FILELSAVE', 'r').read().rstrip()
else:
    filesave = ''

if os.path.isfile(reptemp+'/REPORI'):
    repori = open(reptemp+'/REPORI', 'r').read().rstrip()
else:
    repori = ''

repconfig = HOME+"/.latex-x/config/"
if (os.path.isfile(repconfig+"VIEWCOMPILLOG")) and (open(repconfig+"VIEWCOMPILLOG", 'r').read().rstrip() == 'VIEW'):
    compilmessages = _("See the messages")
else:
    compilmessages = _("Do not see the mesages")
if (os.path.isfile(repconfig+"VIEWCOMPILLOGdvips")) and (open(repconfig+"VIEWCOMPILLOGdvips", 'r').read().rstrip() == 'VIEW'):
    dvipsmessages = _("See the messages")
else:
    dvipsmessages = _("Do not see the mesages")

if (compiltype == 'latex'):
    exporttype = 'PS'
else:
    exporttype = 'PDF'

Version = '3.0'

def stock_label_box(stock, label_text):
    box1 = Gtk.HBox(False, 0)
    box1.set_border_width(0)
    image = Gtk.Image()
    image.set_from_stock(stock, Gtk.IconSize.BUTTON)
    label = Gtk.Label()
    label.set_markup(label_text)
    box1.pack_start(image, False, False, 2)
    box1.pack_start(label, False, False, 1)
    image.show()
    label.show()
    return box1

# options.radoilist :
radiolistLaTeXXchoice1 = _("Choice of the file to compil")
radiolistLaTeXXchoice2 = _("Recent files")
radiolistLaTeXXchoice3 = _("Preferences")
radiolistLaTeXXchoice4 = _("LaTeX-X Help")
radiolistLaTeXXviewchoicechoice1 = _("Visualisation in PS format: ")+_("Compilation ")+"« latex »"+_(" of ")
radiolistLaTeXXviewchoicechoice2 = _("Visualisation in PDF format: ")+_("Compilation ")+"« pdflatex »"+_(" of ")
radiolistLaTeXXviewchoicechoice3 = _("Visualisation in PDF format: ")+_("Compilation ")+"« pdflatex"+_(" with ")+"Postscript (pst-pdf) »"+_(" of ")
radiolistLaTeXXviewchoicechoice4 = _("Visualisation in PDF format: ")+_("Compilation ")+"« latex + ps2pdf»"+_(" of ")
radiolistLaTeXXviewchoicechoice5 = _("Visualisation in PDF format: ")+_("Compilation ")+"« xelatex »"+_(" of ")
radiolistLaTeXXchoixmodechoice1 = _("Visualisation of the PostScript or the PDF")
radiolistLaTeXXchoixmodechoice2 = _("Export to PostScript or to PDF")
radiolistcompilmodechoice1 = _("Visualisation of the PostScript or the PDF")
radiolistcompilmodechoice2 = _("Export to PostScript or to PDF")
radiolistLaTeXXexportchoicechoice1 = _("Export to PostScript")
radiolistLaTeXXexportchoicechoice2 = _("Export to PDF (pdflatex)")
radiolistLaTeXXexportchoicechoice3 = _("Export to PDF (pdflatex with Postscript (pst-pdf))")
radiolistLaTeXXexportchoicechoice4 = _("Export to PDF (latex and ps2pdf)")
radiolistLaTeXXexportchoicechoice5 = _("Export to PDF (xelatex)")
radiolistLaTeXpreferenceschoice1 = _("Choice of the command for the LaTeX editor (actual choice : ")
radiolistLaTeXpreferenceschoice2 = _("Choice of the command for the PostScript viewer (actual choice : ")
radiolistLaTeXpreferenceschoice4 = _("Choice of the command for the PDF viewer (actual choice : ")
radiolistLaTeXpreferenceschoice5 = _("Choice of the command for the text editor (actual choice : ")
radiolistLaTeXpreferenceschoice6 = _("Choice of the command for the html editor (actual choice : ")
radiolistLaTeXpreferenceschoice7 = _("Visualisation of the compilation messages (actual choice : ")+compilmessages+')'
radiolistLaTeXpreferenceschoice8 = _("Visualisation of the dvips messages (actual choice : ")+dvipsmessages+')'
radiolistLaTeXXsaveterminerpschoice1 = _("Modify a file of the temporary directory of compilation and run a compilation of the temporary tex file")
radiolistLaTeXXsaveterminerpschoice2aFILENAMEpsradiolistLaTeXXsaveterminerpschoice2bREPORI = _("Save ")+filename+'.ps '+_("in ")+repori
radiolistLaTeXXsaveterminerpschoice2aFILENAMEdviradiolistLaTeXXsaveterminerpschoice2bREPORI = _("Save ")+filename+'.dvi '+_("in ")+repori
radiolistLaTeXXsaveterminerpschoice2aFILENAMEdviradiolistLaTeXXsaveterminerpschoice4FILENAMEpsradiolistLaTeXXsaveterminerpschoice2bREPORI = _("Save ")+filename+'.dvi '+_("and ")+filename+'.ps '+_("in ")+repori
radiolistLaTeXXsaveterminerpschoice5 = _("Save under...")
saveFILENAMEpsasFILELSAVEps = _("Save ")+filename+'.ps '+_("as ")+filesave+'.ps'
saveFILENAMEdviasFILELSAVEdvi = _("Save ")+filename+'.dvi '+_("as ")+filesave+'.dvi'
saveFILENAMEdviandFILENAMEpsasFILELSAVEdviandFILELSAVEps = _("Save ")+filename+'.ps '+_("and ")+filename+'.dvi '+_("as ")+filesave+'.ps '+_("and ")+filesave+'.dvi'
radiolistLaTeXXsaveterminerpdfchoice1 = _("Modify a file of the temporary directory of compilation and run a compilation of the temporary tex file")
saveFILENAMEpdfinREPORI = _("Save ")+filename+".pdf "+_("in ")+repori
radiolistLaTeXXsaveterminerpdfchoice3 = _("Save under...")
radiolistLaTeXconfigviewlogbinchoicechoice1 = _("I dont want to see the messages")
radiolistLaTeXconfigviewlogbinchoicechoice2 = _("I want to see the mesages")
# end

# options.btitle
backtitleLaTeXX = _("WELLCOME ON LaTeX-X")
backtitlerecompilation_COMPILTYPE = _("Simple compilation")+' '+compiltype
backtitleerrorrecompil = _("PROBABLE ERROR OF COMPILATION")
backtitleerrorcompil = _("EVENTUAL ERROR OF COMPILATION")
backtitleLaTeXXviewchoicecompil = _("CHOICE OF THE COMPILATION")
backtitleLaTeXXexportchoiceformat = _("CHOICE OF THE FORMAT")
backtitleLaTeXXsaveterminerps = _("END OF COMPILATION")
backtitleLaTeXXsavesave = _("SAVE UNDER...")
backtitleLaTeXXsaveterminerpdf = _("END OF COMPILATION")
backtitleexecuteviewps = _("Save?")
backtitleexecuteviewpdf = _("Save?")
backtitlelock = _("! ERROR !")
backtitleerrorparameditor = _("ERROR")
backtitleerrordirnameeditor = _("ERROR")
backtitleerrorpermission = _("ERROR OF PERMISSION")
backtitleerrorext = _("ERROR ON THE NAME OF THE FILE")
backtitleerrornonlatex2e = _("PROGRAMME STOPED")
backtitleconfigviewpdf = _("ERROR ON THE CHOICE OF THE PDF VIEWER")
backtitleconfigviewpostscript = _("ERROR ON THE CHOICE OF THE POSTSCRIPT VIEWER")
backtitleconfigeditortex = _("ERROR ON THE CHOICE OF THE LaTeX EDITOR")
backtitleconfigeditortext = _("ERROR ON THE CHOICE OF THE text EDITOR")
backtitleLaTeXconfigeditorbin = _("CHOICE FOR THE TEXT EDITOR")
backtitleLaTeXconfigeditorbinerror = _("ERROR ON THE CHOICE FOR THE COMMAND OF THE EDITIOR")
backtitleLaTeXconfigeditortexbin = _("CHOICE FOR THE LaTeX EDITOR")
backtitleLaTeXconfigeditortexbinerror = _("ERROR ON THE CHOICE FOR THE COMMAND OF THE EDITIOR")
backtitleLaTeXconfigviewlogbinchoice = _("VISUALISATION OF THE MESSAGES OF COMPILATION")
backtitleLaTeXconfigviewlogdvipschoice = _("VISUALISATION OF THE MESSAGES OF DVIPS")
backtitleLaTeXconfigviewpdfbin = _("CHOICE OF THE PDF VIEWER")
backtitleLaTeXconfigviewpdfbinerror = _("ERROR ON THE CHOICE FOR THE COMMAND OF THE PDF VIEWER")
backtitleLaTeXconfigviewpsbin = _("CHOICE OF THE POSTSCRIPT VIEWER")
backtitleLaTeXconfigviewpsbinerror = _("ERROR ON THE CHOICE FOR THE COMMAND OF THE POSTSCRIPT VIEWER")
backtitlecompilmode = _("COMPILATION MODE")
UNINSTALLT = _("Uninstallation of LaTeX-X ")+Version
backtitleerrornonpermission = _("ERROR ON THE FILE")
backtitleLaTeXXchoix = _("CHOOSE")
backtitleerrorexttex = _("ERROR ON THE CHOICE OF FILE")
infoboxupdateerrortitle = _("ERROR")
infoprecomppstpdfnopage = _("INFORMATION")
backtitleLaTeXXrecents = _("RECENTLY OPENED FILES")
backtitleLaTeXconfigviewhtmlbin = _("CHOICE OF THE HTML VIEWER")
backtitleLaTeXpreferences = _("PREFERENCES")
# end

# options.label
radiolistLaTeXX = _("Choose the LaTeX2e file to compile.\nYou can also configure LaTeX-X in the Preferences,\nor consult the LaTeX-X help.")
yesnorecompilation1_tmp_FILENAMEtex_yesnorecompilation2 = _("Run the compilation of tmp_")+filename+'.tex\n'+_("To see the changes\nupdate the viewer\nthen close it to continue.")
emerstoprecompil1_FILENAMEtex_emerstoprecompil2_FILENAMElog_emerstoprecompil3 = _("The compilation of ")+filename+'.tex '+_("abort because of a critical error")+'\n'+_("in the file you just modify! Please consult the messages file")+'\n'+filename+'.log\n'+_("TO CORRECT: close the editor, click on the Close button")+'\n'+_("and restart all the process.")
msgboxerrorrecompil1_FILENAMElog_msgboxerrorrecompil2 = _("Probable LaTeX error!\nThe compilation is finbished but there is probavly aLaTeX error\nin the file you just modify!\nConsult the messagefile")+'\n'+filename+'.log\n'+_("TO CORRECT: close the edotor, click on OK and restart the process.")
infoboxemerlogcompil1_FILENAMEtex_infoboxemerlogcompil2_FILENAMElog_infoboxemerlogcompil3 = _("The compilation of")+'\n'+filename+'.tex\n'+_("failed because there is\na critical LaTeX error!\nPlease consult the message file")+'\n'+filename+'.log\n'+_("to correct it after.")
yesnowarningfirstcompil1_EXPORTTYPE_yesnowarningfirstcompil2_EXPORTTYPE_yesnowarningfirstcompil3 = "! LaTeX Warning !\n"+_("The compilation is finished without errors but there are some warnings")+'\n'+_("What do you want to do? You can ignore these warnings and see")+'\n'+_("immediately the ")+exporttype+_(" using the apropriate button, or look at them and decice after.")+'\n'+_("If youy decide to correct a mistake, the ")+exporttype+_(" will not be created")+'\n'+_("and the temporary directory of compilation will be emptied.")
yesnoerrorcompil1_EXPORTTYPE_yesnoerrorcompil2_EXPORTTYPE_yesnoerrorcompil3_EXPORTTYPE_yesnoerrorcompil4_newline_yesnoerrorfirstcompil = _("! Eventual LaTeX Error !")+'\n'+_("The ")+exporttype+_(" is corrutted or empty!\n What do you want to do? You can forget these errors\nand immediately see the ")+exporttype+_(" using the apropriare button,\nor look at the messages and decide after.\n If you decide to correct a mistake, the ")+exporttype+_(" will not be created.")+'\n'+_(" Moreover the compilation directory will be emptied.")
yesnoerrorcompil1_EXPORTTYPE_yesnoerrorcompil2_EXPORTTYPE_yesnoerrorcompil3_EXPORTTYPE_yesnoerrorcompil4 = _("! Eventual LaTeX Error !")+'\n'+_("The ")+exporttype+_(" is corrutted or empty!\n What do you want to do? You can forget these errors\nand immediately see the ")+exporttype+_(" using the apropriare button,\nor look at the messages and decide after.\n If you decide to correct a mistake, the ")+exporttype+_(" will not be created.")
labelnopageoutputfirstcompil_FILENAME = _("Following an error, the compilation of")+'\n'+filename+".tex\n"+_("did not produce a ")+exporttype+ _(" file")+'\n'+_("Please look at the LaTeX log ")+'\n'+filename+".log"
infoboxemerlogcompil1_FILENAMEtex_infoboxemerlogcompil2_newline_FILENAMElog_newline_infoboxemerlogcompil3 = _("The compilation of")+'\n'+filename+".tex\n"+_("failed because there is\na critical LaTeX error!\nPlease consult the message file.")+'\n'+_("to correct it after.")
FILENAMEtex_newline_yesnonoupdatecompilneeded = filename+".tex\n"+_("does not change.\n Do you want to run an other compilation?")
FILENAMEtexnewline_yesnonoupdatecompilneededpsopen1_newline_FILENAMEps_newline_yesnonoupdatecompilneededpsopen2 = filename+".tex\n"+_("does not chenge and")+'\n'+_("is allready edited.\n Do you want to run an other compilation?")
FILENAMEtex_updatecompilnotchangeerror_logfile = filename+".tex\n"+_("Does not change! BUT:\n You did not correct an error\nwhich produces an ")+'«emergency stop»\n'+_("or a ")+exporttype+_(" file empty.\n You must correct it first!\nConsult the log file which will be displayed.")
yesnowarningupdatecompil1_EXPORTTYPE_yesnowarningupdatecompil2_EXPORTTYPE_yesnowarningupdatecompil3 = "! LaTeX Warning !"+'\n'+_("The compilation is finished without errors but there are some new warnings.\n What do you want to do? You can ignore these warnings and see immediately\nthe ")+exporttype+_("using the apropriate button, or look at them and decide after.\n If you decide to correct a mistake, the ")+exporttype+_(" will not be created")
radiolistLaTeXXviewchoicecompil2 = _("The compilation is done in mode nonstop. Then the errors which does not stop the compilator are corrected automaticaly.newlineIt is allways better to look at the LaTeX log file which can be viewed at the end of the compilation.\n All the choices allow to make any modification on the original tex file and on the files produced by the compilation.")
radiolistLaTeXXexportchoiceformat1_newline_FILENAMEtex_newline_radiolistLaTeXXexportchoiceformat2 = _("Choose under which format you want do the exportation of")+'\n'+filename+".tex\n"+_("If the compilation has been yet done, it will not be done again.\n If not, it will be.")
radiolistLaTeXXsaveterminerps1_newline_tmp_FILENAMEtex_newline_radiolistLaTeXXsaveterminerps2 = _("Choose what you want to do to finish the compilation of")+'\ntmp_'+filename+".tex\n"+_("The compilation run latex only once.")
radiolistLaTeXXsavesave = _("Choose the files you want to save")
radiolistLaTeXXsaveterminerpdf1_tmp_FILENAMEtex_radiolistLaTeXXsaveterminerpdf2 = _("Choose what you want to do to finish the compilation of")+'\ntmp_'+filename+".tex\n"+_("The compilation run pdflatex or xelatex only once.")
yesnexecuteviewpsFILENAMEps = _("Do you want to save ")+filename+'.ps'
yesnexecuteviewpdfFILENAMEpdf = _("Do you want to save ")+filename+'.pdf'
yesnolock = _("LaTeX-X cannot run safely because the temporary\ndirectory is not empty.\n\n Or there is a session of LaTeX-X which is not finished\n\n Or a crash of LaTeX-X let the temporary\ndirectory non empty.\n\n In the first cas click on \"Close\" and\nfinish the actual session.\n\n In the second case click on \"Delete\" and\nrestart LaTeX-X.")
infoboxerrorparameditor  =_("The command line use by your editor\nor your file manager is written with\nwrong parameters.\n Try to modifiy it, using the help of LaTeX-X,\ntyping \" latex-x --doc \" in a terminal or with the\ngrapical interface of \" LaTeX-X \".")
infoboxerrordirnameeditor = _("LaTeX-X cannot determine the names of the directory\nand the file to compile. Please verifiy the way used to run\nlatex-x on the file. Good luck!")
infoboxerrornonpermission = _("The file you run \" latex-x \" on does not exist\nor you dont have permission to read it.\n Rerun \" latex-x \" on a file you can read.\n Good bye...")
infoboxerrorext = _("The file you choose does not have the extension \" .tex \".\n LaTeX-X cannot compile correctly this file.\n You have to remane this file adding it this extension.\n Good bye...")
msgboxerrornonlatex2e = _("ERROR ON THE TYPE OF FILE")+'\n\n'+_("The file you choose does not seem to be\na LaTeX2e file:\documentclass[...]{...}\nis missing at the begening.\n LaTeX-X cannot compile this file!\n Good bye...")
infoboxconfigviewpdf = _("The PDF viewer you choose does not exist.\n Click on \" OK \" to choose an other one with the next window.")
infoboxconfigviewpostscript = _("The PostScript viewer you choose does not exist.\n Click on \" OK \" to choose an other one with the next window.")
infoboxconfigeditortext = _("The text editor you choose does not exist.\n Click on \" OK \" to choose an other one with the next window.")
inputboxLaTeXconfigeditorbin = _("Write the command of your prefered text editor.\n For example emacs, gedit, ...\n The actual choice apears in the choice field.\n You can add parameters to that command if you want.")
infoboxLaTeXconfigeditorbinerror = _("The command you choose does not exist.\n Click on \" OK  \" to choose an other one with the next window.")
inputboxLaTeXconfigeditortexbin = _("Write the command of your prefered text editor.\n For example emacs, gedit, texmaker, texstudio, ...\n The actual choice apears in the choice field.\n You can add parameters to that command if you want")
infoboxLaTeXconfigeditortexbinerror = _("The command you choose does not exist.\n Click on \" OK  \" to choose an other one.")
radiolistLaTeXconfigviewlogbinchoice = _("You can choose either to see the messages produced\n during the compilation or not. If you choose\n to see them, in certain cases, they do not appear immediately. Be patient!\n Choose below")
radiolistLaTeXconfigviewlogdvipschoice = _("You can choose either to see the messages produced\nby dvips or not.\n Choose below")
inputboxTeXconfigviewpdfbin = _("Write the command name of your prefered PDF viewer.\n For example, acroread, xpdf, ...\n The actual choice appears in the choice field.\n You can add parameters to the command if you want.\n For example \"acroread tempFile\".")
infoboxLaTeXconfigviewpdfbinerror = _("The command you choose does not exist.\n Click on \" OK \" to choose an other one\nwith the following window.")
inputboxLaTeXconfigviewpsbin = _("Write the command name of the PostScript viewer you want to use.\n For example gv, evince ...\n The actual choice appears in the choice field.\n You can add all the parametters you want.")
radiolistcompilmode = _("Choose if you want to visualise or to export")+'\n'+FILE
infoboxerrornonlatex2e1_FILE_infoboxerrornonlatex2e2 = _("ERROR ON THE TYPE OF FILE")+'\n'+FILE+'.tex\n'+_("does not seem to be a LaTeX2e file:\n\documentclass[...]{...} is missing at the begening.\n LaTeX-X cannot compile this file!\n Good bye...")
UNINSTALLQ = _("Are you sure you want to uninstall LaTeX-X ")+Version
infoboxerrornonpermission1_FILE_infoboxerrornonpermission2 = _("The file ")+FILE+'.tex\n'+_("you run LaTeX-X on does not exist or you dont have permission to read it.\n Else you rerun LaTeX-X on the wrigth file,\n or you choose an other file with the next window.")
backtitleLaTeXXchoixmode_FILE = _("COMPILATION MODE\nChoose if you want to view or export\n")+FILE
infoboxerrorexttex = _("You run LaTeX-X on a file which have not the extension .tex.\n Else you rename it or you choose an other with the next window.")
FILENAMEtex_yesnotestpstpdf1_yesnotestpstpdf2 = filename+".tex\n"+_("does not seems to use pst-pdf")+'\n'+_("Are you sure you want to continue?")
infoboxupdateerror123456 = filename+".tex\n"+_("does not change BUT:")+'\n'+_("You did not corretc a mistake")+'\n'+_("which produced a \"emergency stop\"")+'\n'+_("or an empty DVI file.")+'\n'+_("You must correct it!")+'\n'+_("Look at the log file.")
infoboxemerlogcompil12_FILENAMEtex_infoboxemerlogcompil2_FILENAMElog_infoboxemerlogcompil3 = _("The precompilation of")+'\n'+filename+".tex\n"+_("failled because there is a critical LaTeX error!\n Please consult the message file")+'\n'+filename+".log\n"+_("to correct it after.")
precomppstpdf123456 = _("The precompilation of")+'\n'+filename+".tex\n"+_("did not produces a DVI file.")+'\n'+_("It can be due to an error or because pst-pdf")+'\n'+_("did not detect a Postscript code.")+'\n'+_("What do you want to do?")+'\n'+_("Continue the compilation with pdflatex?")+'\n'+_("Look at the log file and correct a mistake?")
yesnoprecomperror12345 = _("! Eventual LaTeX Error !")+'\n'+_("The pre-compilation is finished but there may be errors LaTeX in the TeX file!")+'\n'+_("May be the DVI is corrupted or empty!")+'\n'+_("What do you want to do?")+"\n"+_(" You can forget these errors and continue the compilation, or look at at the messages and decide")+'\n'+_("after.")+'\n'+_("With the second choice, if you decide to corect a mistake, the DVI will not be created, and the")+'\n'+_("compilation directory will be emptied.")
FILENAMEtex_yesnonoupdatecompilneededpsopen12 = filename+".tex\n"+_("does not change for the PostScript code.")+'\n'+_("Do you want to run an additional pre-compilation?")
inputboxLaTeXconfigviewhtmlbin = _("Write the command name of the html viewer you want to use.\n For example firefox ...\n The actual choice appears in the choice field.\n You can add all the parametters you want.")
radiolistLaTeXpreferences = _("Choose what you want to modify.\n To configure your choice, click on \" Next \"\n To come back click on \" Previous \"")
# end

# options.yesbutton
oklabelrecompilation_FILENAMEtex = _("Compil ")+filename+'.tex'
oklabelwarningcompil = _("Look at LaTeX Warning")
oklabelerrorcompil = _("Look at LaTeX messages")
prepstpdfcorr = _("Correct a mistake")
# end

# options.nobutton
cancellabelrecompilation = _("Close without compilation")
prepstfcont = _("Continue the compilation")
# end

# options.viewbutton
cancellabelfirstviewwarningcompil_EXPORTTYPE = _("Forget and create the ")+exporttype
cancellabelerrorcompil_EXPORTTYPE = _("Forget the log and create the ")+exporttype
cancellabelwarningcompil_EXPORTTYPE = _("Forget and create The ")+exporttype
# end

# options.logbutton
oklabelfirstviewwarningcompil = _("Correct a mistake")
oklabelfirstviewlogerrorcompil = _("Correct the mistake")
# end
